#include <opencv2/opencv.hpp>

int main_motion()
{
    cv::VideoCapture camera(0, cv::CAP_DSHOW);

    cv::Mat frame, gray, previous_gray, delta_frame, thresh_frame;

    for (;;) {
        camera >> frame;
        if (frame.empty()) break;

        cv::cvtColor(frame, gray, cv::COLOR_BGR2GRAY);
        cv::GaussianBlur(gray, gray, cv::Size(21, 21), 0);

        if (!previous_gray.empty()) {

            cv::absdiff(previous_gray, gray, delta_frame);
            cv::imshow("delta Frame", delta_frame);

            cv::threshold(delta_frame, thresh_frame, 30, 255, cv::THRESH_BINARY);
            cv::dilate(thresh_frame, thresh_frame, cv::getStructuringElement(cv::MORPH_RECT, cv::Size(3, 3)), cv::Point(-1, -1), 2);

            std::vector<std::vector<cv::Point>> cnts;
            cv::findContours(thresh_frame.clone(), cnts, cv::RETR_EXTERNAL, cv::CHAIN_APPROX_SIMPLE);

            for (auto &contour : cnts) {
                if (cv::contourArea(contour) < 2000) continue;

                cv::Rect rect = cv::boundingRect(contour);
                cv::rectangle(frame, rect, cv::Scalar(0, 255, 0), 2);
            }
            cv::imshow("thresh Frame", thresh_frame);
        }
        previous_gray = gray.clone();

        cv::imshow("Color Frame", frame);

        if (cv::waitKey(10) == 27) break;
    }

    camera.release();
    cv::destroyAllWindows();
    return 0;
}
