#include <opencv2/opencv.hpp>
#include <opencv2/saliency.hpp>

int main_saliency()
{
    cv::Ptr<cv::saliency::StaticSaliencyFineGrained> saliency = cv::saliency::StaticSaliencyFineGrained::create();

    cv::VideoCapture camera(0, cv::CAP_DSHOW);

    cv::Mat previous_gray, frame, saliencyMap, threshMap;

    for (;;) {
        camera >> frame;
        if (frame.empty()) break;

        saliency->computeSaliency(frame, saliencyMap);
        saliencyMap *= 255;
        saliencyMap.convertTo(saliencyMap, CV_8UC1);

        cv::threshold(saliencyMap, threshMap, 0, 255, cv::THRESH_BINARY | cv::THRESH_OTSU);

        cv::imshow("Image", frame);
        cv::imshow("Saliency map", saliencyMap);
        cv::imshow("Thresh map", threshMap);

        if (cv::waitKey(10) == 27) break;
    }

    camera.release();
    cv::destroyAllWindows();
    return 0;
}
