import numpy as np
import cv2

saliency = cv2.saliency.StaticSaliencyFineGrained_create()

camera = cv2.VideoCapture(0,cv2.CAP_DSHOW)

while True:
    hasFrame, frame = camera.read() 
    if not hasFrame: 
        break

    (success, saliencyMap) = saliency.computeSaliency(frame)
    saliencyMap = (saliencyMap*255).astype("uint8")
    _, threshMap = cv2.threshold(saliencyMap, 0, 255, cv2.THRESH_BINARY | cv2.THRESH_OTSU)
    
    cv2.imshow("Image", frame)
    cv2.imshow("Saliency map", saliencyMap)
    cv2.imshow("Thresh map", threshMap)
    
    if cv2.waitKey(10) ==  27:
        break
        
camera.release()
cv2.destroyAllWindows()
