#include <opencv2/opencv.hpp>
#include <opencv2/saliency.hpp>

int main_saliency_motion()
{
    cv::Ptr<cv::saliency::MotionSaliencyBinWangApr2014> saliency = nullptr;

    cv::VideoCapture camera(0, cv::CAP_DSHOW);

    cv::Mat frame, gray, saliencyMap;

    for (;;) {
        camera >> frame;
        if (frame.empty()) break;

        if (saliency == nullptr) {
            saliency = cv::saliency::MotionSaliencyBinWangApr2014::create();
            saliency->setImagesize(frame.cols, frame.rows);
            saliency->init();
        }

        cv::cvtColor(frame, gray, cv::COLOR_BGR2GRAY);
        saliency->computeSaliency(gray, saliencyMap);
        saliencyMap *= 255;
        saliencyMap.convertTo(saliencyMap, CV_8UC1);

        cv::imshow("Image", frame);
        cv::imshow("Saliency map", saliencyMap);

        int key = cv::waitKey(10);
        if (key == 27) break;
        else if (key == 'r') saliency = nullptr;
    }

    camera.release();
    cv::destroyAllWindows();
    return 0;
}
