import numpy as np
import cv2

camera = cv2.VideoCapture(0,cv2.CAP_DSHOW)

_, frame = camera.read()

saliency = cv2.saliency.MotionSaliencyBinWangApr2014_create()
saliency.setImagesize(frame.shape[1], frame.shape[0])
saliency.init()

while True:
        
    gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
    _, saliencyMap = saliency.computeSaliency(gray)
	
    cv2.imshow("Image", frame)
    cv2.imshow("Saliency map", (saliencyMap * 255).astype("uint8"))
    
    key = cv2.waitKey(10)
    if key ==  27:
        break

    _, frame = camera.read() 
    
camera.release()
cv2.destroyAllWindows()
